package abacus.springboot.example.util;


import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
/**
 * <p>Title:DateToUpperChinese</p>
   <p>Description: 日期转成中文大写形式</p>
   @author chuanZeng 
   @date 2026年8月18日
 */
public class DateToUpperChinese {
    private static final String[] NUMBERS = {"零", "壹", "贰", "叁", "肆", "伍",
            "陆", "柒", "捌", "玖"};

    /**
     * 通过 yyyy-MM-dd 得到中文大写格式 yyyy MM dd 日期
     */
    public static synchronized String toChinese(String str) {
        StringBuffer sb = new StringBuffer();
        sb.append(getSplitDateStr(str, 0)).append(" ").append(
                getSplitDateStr(str, 1)).append(" ").append(
                getSplitDateStr(str, 2));
        return sb.toString();
    }

    /**
     * 分别得到年月日的大写 默认分割符 "-"
     */
    public static String getSplitDateStr(String str, int unit) {
        // unit是单位 0=年 1=月 2日
        String[] DateStr = str.split("-");
        if (unit > DateStr.length)
            unit = 0;
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < DateStr[unit].length(); i++) {

            if ((unit == 1 || unit == 2) && Integer.valueOf(DateStr[unit]) > 9) {
                sb.append(convertNum(DateStr[unit].substring(0, 1)))
                        .append("拾").append(
                                convertNum(DateStr[unit].substring(1, 2)));
                break;
            } else {
                sb.append(convertNum(DateStr[unit].substring(i, i + 1)));
            }
        }
        if (unit == 1 || unit == 2) {
            return sb.toString().replaceAll("^壹", "").replace("零", "");
        }
        return sb.toString();

    }

    /**
     * 转换数字为大写
     */
    private static String convertNum(String str) {
        return NUMBERS[Integer.valueOf(str)];
    }
    public final static char[] upper = "零一二三四五六七八九十".toCharArray();

    /**
     * 根据小写数字格式的日期转换成大写格式的日期
     * @param date
     * @return
     */
    public static String getUpperDate(Date datez) {
    	
        //支持yyyy-MM-dd、yyyy/MM/dd、yyyyMMdd等格式
        if(datez == null) return null;
        
        SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd");
        String date = sdf.format(datez);
        
        
        //非数字的都去掉
        date = date.replaceAll("\\D", "");
        if(date.length() != 8) return null;
        StringBuilder sb = new StringBuilder();
        for (int i=0;i<4;i++) {//年
            sb.append(upper[Integer.parseInt(date.substring(i, i+1))]);
        }
        sb.append("年");//拼接年
        int month = Integer.parseInt(date.substring(4, 6));
        if(month <= 10) {
            sb.append(upper[month]);
        } else {
            sb.append("十").append(upper[month%10]);
        }
        sb.append("月");//拼接月

        int day = Integer.parseInt(date.substring(6));
        if (day <= 10) {
            sb.append(upper[day]);
        } else if(day < 20) {
            sb.append("十").append(upper[day % 10]);
        } else {
            sb.append(upper[day / 10]).append("十");
            int tmp = day % 10;
            if (tmp != 0) sb.append(upper[tmp]);
        }
        sb.append("日");//拼接日
        return sb.toString();
    }
    /**
     * 判断是否是零或正整数
     */
    public static boolean isNumeric(String str) {
        Pattern pattern = Pattern.compile("[0-9]*");
        Matcher isNum = pattern.matcher(str);
        if (!isNum.matches()) {
            return false;
        }
        return true;
    }

    public static void main(String args[]) {
        System.out.println(getUpperDate(new Date()));
        
        double d = 1000.0000;
        
        String str = String.valueOf(d);
        
        if(str.indexOf(".") > 0) {
        	str = str.replace("0+?$", "");// 删除掉尾数为0的字符
        	str = str.replace("[.]$", "");// 结尾如果是小数点，则去掉
        }
        System.out.println(str);
//        System.out.println(dStr.replace("\\.0*$", ""));

    }
}









